// u_30_profiling
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_to_profile;
  interface
    uses sysutils;

    type i_my_interface=
             interface
               procedure const_interface_call(const p_i_my_interface: i_my_interface; p_count: Integer);
               procedure interface_call(p_i_my_interface: i_my_interface; p_count: Integer);
             end; // i_my_interface

         c_my_class=
             class(TInterfacedObject, i_my_interface)
               procedure const_non_virtual_call(const p_c_my_class: c_my_class; p_count: Integer);
               procedure non_virtual_call(p_c_my_class: c_my_class; p_count: Integer);
               procedure virtual_call(p_c_my_class: c_my_class; p_count: Integer); virtual;
               procedure const_interface_call(const p_i_my_interface: i_my_interface; p_count: Integer);
               procedure interface_call(p_i_my_interface: i_my_interface; p_count: Integer);

               procedure non_virtual_global_call(p_count: Integer);
             end; // c_my_class

    procedure recursive_call(p_count: Integer);

    type t_ap= reference to procedure(p_ap: t_ap; p_count: Integer);
    type t_ap_const= reference to procedure(const pk_ap: t_ap_const; p_count: Integer);

    var g_c_my_object: c_my_class= Nil;

  implementation

    procedure recursive_call(p_count: Integer);
      begin
        if p_count> 0
          then recursive_call(p_count- 1);
      end; // recursive_call


    { c_my_class }

    procedure c_my_class.interface_call(p_i_my_interface: i_my_interface; p_count: Integer);
      begin
        if p_count> 0
          then p_i_my_interface.interface_call(p_i_my_interface, p_count- 1);
      end; // interface_call

    procedure c_my_class.const_interface_call(const p_i_my_interface: i_my_interface; p_count: Integer);
      begin
        if p_count> 0
          then p_i_my_interface.const_interface_call(p_i_my_interface, p_count- 1);
      end; // const_interface_call

    procedure c_my_class.non_virtual_call(p_c_my_class: c_my_class; p_count: Integer);
      begin
        if p_count> 0
          then non_virtual_call(p_c_my_class, p_count- 1);
      end; // non_virtual_call

    procedure c_my_class.const_non_virtual_call(const p_c_my_class: c_my_class; p_count: Integer);
      begin
        if p_count> 0
          then const_non_virtual_call(p_c_my_class, p_count- 1);
      end; // const_non_virtual_call

    procedure c_my_class.virtual_call(p_c_my_class: c_my_class; p_count: Integer);
      begin
        if p_count> 0
          then virtual_call(p_c_my_class, p_count- 1);
      end; // virtual_call

    procedure c_my_class.non_virtual_global_call(p_count: Integer);
      begin
        if p_count> 0
          then g_c_my_object.non_virtual_global_call(p_count- 1);
      end; // non_virtual_global_call

    end.
